﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HeuristicLab.Algorithms.Bandits {
  public class MeanAndVariancePolicyActionInfo : IPolicyActionInfo {
    private bool disabled;
    public bool Disabled { get { return disabled; } }
    private OnlineMeanAndVarianceEstimator estimator = new OnlineMeanAndVarianceEstimator();
    public int Tries { get { return estimator.N; } }
    public double SumReward { get { return estimator.Sum; } }
    public double AvgReward { get { return estimator.Avg; } }
    public double RewardVariance { get { return estimator.Variance; } }

    public void UpdateReward(double reward) {
      Debug.Assert(!Disabled);
      estimator.UpdateReward(reward);
    }

    public void Disable() {
      disabled = true;
    }

    public void Reset() {
      disabled = false;
      estimator.Reset();
    }

    public void PrintStats() {
      Console.WriteLine("avg reward {0,5:F2} disabled {1}", AvgReward, Disabled);
    }
  }
}
