﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using HeuristicLab.Common;

namespace HeuristicLab.Algorithms.Bandits {
  public class RandomPolicy : IPolicy {

    public override string ToString() {
      return "RandomPolicy";
    }

    public int SelectAction(Random random, IEnumerable<IPolicyActionInfo> actionInfos) {
      return actionInfos
        .Select((a, i) => Tuple.Create(a, i))
        .Where(p => !p.Item1.Disabled)
        .SelectRandom(random).Item2;
    }

    public IPolicyActionInfo CreateActionInfo() {
      return new EmptyPolicyActionInfo();
    }
  }
}
